module TokenServer
    class ApplicationController < ActionController::Base
        protect_from_forgery with: :exception

        before_action :set_account, :authenticate

        private
        def set_account
            # Use the configured Account class
            account_class = Object.const_get(TokenServer.account_class)
            @account = account_class.find_by(url_name: request.subdomains.first)
        end

        def authenticate
            if user = authenticate_with_http_basic { |u, p| @account.authenticate(u, p) }
                @current_user = user
            else
                request_http_basic_authentication
            end
        end
    end
end
